/* FILE: String.H
 * last change: 20-Mar-2001
 * taken from: "Corso di Programmazione c++" Stanley B.Lippman
 *
 * Classe per manipolare stringhe.
 */


#include <iostream.h>

const int RC_MAX = 127;


class string 
{
  int len;	// La lunghezza della Stringa
  char *p;	// Il puntatore alla Stringa

public:
  string()			// Crea una stringa vuota
    { len = 0; p = NULL; }
  string(const char *a);	// Crea stringhe da array
  string(const string &t);	// Copy constructor
  ~string();			// Distruttore


// Operatore di concatenazione
  friend string operator+ (const string &s, const string &t);


// Operatori di confronto ed eguaglianza
  friend int operator== (const string &s, const string &t);
  friend int operator<= (const string &s, const string &t);
  friend int operator>= (const string &s, const string &t)
    { return ((t <= s)); }
  friend int operator!= (const string &s, const string &t)
    { return (!(s == t)); }
  friend int operator> (const string &s, const string &t)
    { return (!(s <= t)); }
  friend int operator< (const string &s, const string &t)
    { return (!(t <= s)); }


// Funzioni per restituire la posizione di una sottostringa, la lunghezza e
// (solo come esempio) il numero di riferimenti alla stringa
  friend int pos(const string &s, const string &t, int i = 1);
  friend int length(const string &s)
    { return (s.len); }
  friend int refs(const string &s)
    { return (s.p == 0 ? 0 : *s.p); }
  

// Operatori di assegnamento
  string& operator= (const string &t);
  string& operator+= (const string &t);


// Operatori di subscript and substring
  char& operator[] (int i);
  string operator() (int i, int n) const;


// Operatori di inserimento ed estrazione
  friend istream & operator>> (istream &ci, string &t);
  friend ostream & operator<< (ostream &co, const string &t);
};
